<?

 /*****************************************************************************
 * Filename: include/modules/configWYSIWYG.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["modules"]."config.php");

 class System_Module_configWYSIWYG extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   $this->data->title="WYSIWYG configuration";

   $this->data->defaultFields("id;added;updated");
   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all
   $this->data->addField("faketitle", "text", "show", "title;hidden", 0, false, $this->data->title, "Title");

   $this->data->addField("translate", "boolean", "all", false, false, false, true, "Translate");
   $this->data->addField("prettyurls", "boolean", "all", false, false, false, $_config->get("prettyurls"), "Pretty URLs");


   $this->data->addField("bold", "boolean", "all", false, false, false, true, "Bold");
   $this->data->addField("italic", "boolean", "all", false, false, false, true, "Italic");
   $this->data->addField("underline", "boolean", "all", false, false, false, true, "Underline");
   $this->data->addField("strikeThrough", "boolean", "all", false, false, false, true, "Strike through");
   $this->data->addField("fontsize", "boolean", "all", false, false, false, true, "Font size");

   $this->data->addField("label1", "label", "form", false, false, false, false, "Style");
   $this->data->addField("h1", "boolean", "all", false, false, false, true, "Header 1");
   $this->data->addField("h2", "boolean", "all", false, false, false, true, "Header 2");
   $this->data->addField("h3", "boolean", "all", false, false, false, true, "Header 3");
   $this->data->addField("h4", "boolean", "all", false, false, false, true, "Header 4");
   $this->data->addField("h5", "boolean", "all", false, false, false, true, "Header 5");
   $this->data->addField("h6", "boolean", "all", false, false, false, true, "Header 6");
   $this->data->addField("paragraph", "boolean", "all", false, false, false, true, "Paragraph");

   $this->data->addField("label2", "label", "form", false, false, false, false, "Lists");
   $this->data->addField("bulletList", "boolean", "all", false, false, false, true, "Bullets");
   $this->data->addField("numberList", "boolean", "all", false, false, false, true, "Numbers");

   $this->data->addField("label3", "label", "form", false, false, false, false, "");
   $this->data->addField("outdent", "boolean", "all", false, false, false, true, "Outdent");
   $this->data->addField("indent", "boolean", "all", false, false, false, true, "Indent");

   $this->data->addField("label4", "label", "form", false, false, false, false, "Align");
   $this->data->addField("alignLeft", "boolean", "all", false, false, false, true, "Left");
   $this->data->addField("alignCenter", "boolean", "all", false, false, false, true, "Center");
   $this->data->addField("alignRight", "boolean", "all", false, false, false, true, "Right");

   $this->data->addField("label5", "label", "form", false, false, false, false, "");
   $this->data->addField("removeFormat", "boolean", "all", false, false, false, true, "Remove format");
   $this->data->addField("specialCharacters", "boolean", "all", false, false, false, true, "Special characters");


   $this->data->addField("links", "boolean", "all", false, false, false, true, "Links");
   $this->data->addField("email", "boolean", "all", false, false, false, true, "E-mail links");

   $this->data->addField("files", "boolean", "all", false, false, false, true, "File links");
   $this->data->addField("filesModules", "modules", "all", false, false, 255, "files", "Allowed file modules");

   $this->data->addField("images", "boolean", "all", "reload", false, false, true, "Images");
   $this->data->addField("imagesModules", "modules", "all", false, false, 255, "images", "Allowed image modules");
   $this->data->addField("imagesThumbWidth", "nr", "all", false, 10, 1000, 100, "Thumbnail width");
   $this->data->addField("imagesDefaultWidth", "nr", "all", false, 10, 1000, 400, "Default width");

   $this->data->addField("undo", "boolean", "all", false, false, false, true, "Undo");
   $this->data->addField("redo", "boolean", "all", false, false, false, true, "Redo");

   $this->data->addField("label6", "label", "form", false, false, false, false, "");
   $this->data->addField("copy", "boolean", "all", false, false, false, true, "Copy");
   $this->data->addField("paste", "boolean", "all", false, false, false, true, "Paste");
   $this->data->addField("cut", "boolean", "all", false, false, false, true, "Cut");
   $this->data->addField("delete", "boolean", "all", false, false, false, true, "Delete");

   $this->data->addField("label7", "label", "form", false, false, false, false, "");
   $this->data->addField("iframe", "boolean", "all", false, false, false, true, "WYSIWYG hide / show");
   $this->data->addField("textarea", "boolean", "all", false, false, false, true, "Textarea hide / show");
   $this->data->addField("fullscreen", "boolean", "all", false, false, false, true, "Full screen");


   $this->data->group("Formatting",
    "bold", "italic", "underline", "strikeThrough", "fontsize", "label1",
    "h1", "h2", "h3", "h4", "h5", "h6", "paragraph", "label2",
    "bulletList", "numberList", "label3",
    "indent", "outdent", "label4",
    "alignLeft", "alignCenter", "alignRight", "label5",
    "removeFormat", "specialCharacters"
   );

   $this->data->group("Links", "links", "email");

   $this->data->group("Files", "files", "filesModules");
   $this->data->group("Images", "images", "imagesModules", "imagesThumbWidth", "imagesDefaultWidth");

   $this->data->group("Tools",
    "undo", "redo", "label6",
    "copy", "paste", "cut", "delete", "label7",
    "iframe", "textarea", "fullscreen"
   );
  }

  function postInit()
  {
   if($this->data->action=="add"||$this->data->action=="edit")
   {
    if($this->data->getValue("files"))
     $this->data->resetField("filesModules");
    else
     $this->data->field["filesModules"]["properties"].=";hidden";

    if($this->data->getValue("images"))
     $this->data->resetField("imagesModules");
    else
     $this->data->field["imagesModules"]["properties"].=";hidden";

   }

   return true;
  }

  function viewPostGet()
  {
   for($c=0;$c<$this->data->vmax;$c++)
    $this->data->setValue("faketitle", $this->data->title, $c);

   return true;
  }


  function addPostSubmit(){return System_Module_config::updateConfig();}
  function editPostSubmit(){return System_Module_config::updateConfig();}
  function deletePostSubmit(){return System_Module_config::updateConfig();}
 }

?>
