<?

 /*****************************************************************************
 * Filename: include/modules/log.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class System_Module_log extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   $this->data->title="Log";

   $this->data->defaultFields("id;added");
   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 512); //add rights for all

   //error
   $this->data->addField("title", "text", "all", "title", 0, 255, false, "Error");
   $this->data->addField("text", "text", "all", false, 0, 65536, false, "Extra information");

   $this->data->addField("level", "list", "all", false, 0, 10, false, "Level");
   $this->data->listOptions("level", array_merge(Array(""), $this->data->e->errorType));

   //request
   $this->data->addField("url", "url", "all", false, 0, 65536, false, "URL");
   $this->data->addField("vars", "text", "all", false, 0, 65536, false, "Request variables");
   $this->data->addField("ip", "ip", "all", false, false, false, "ip", "IP address");

   $this->data->addField("usernr", "nr", "sql;show", "", 1, false, "usernr", "User");
   $this->data->addReference("usernr", $_config->get("usermodule"), "nr", "*:1");

   //function info
   $this->data->addField("function", "text", "all", false, 0, 65536, false, "Function");
   $this->data->addField("file", "text", "all", false, 0, 65536, false, "File");
   $this->data->addField("line", "nr", "all", false, 0, false, false, "Line number");

   $this->data->sortOrder("added-");

   $this->data->group("Request", "url", "vars", "ip", "usernr");
   $this->data->group("Function info", "function", "file", "line");
  }
 }
?>
