<?

 /*****************************************************************************
 * Filename: include/path.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 //set core paths
 if(!isset($_path["projects"]))
  $_path["projects"]=$_path["root"]."project/";
 if(!isset($_path["images"]))
  $_path["images"]=$_path["root"]."images/";
 if(!isset($_path["script"]))
  $_path["script"]=$_path["root"]."script/";
 if(!isset($_path["modules"]))
  $_path["modules"]=$_path["include"]."modules/";
 if(!isset($_path["plugins"]))
  $_path["plugins"]=$_path["include"]."plugins/";
 if(!isset($_path["api"]))
  $_path["api"]=$_path["include"]."api/";
 if(!isset($_path["format"]))
  $_path["format"]=$_path["include"]."format/";
 if(!isset($_path["protocol"]))
  $_path["protocol"]=$_path["include"]."protocol/";

 //set script filename
 if(!isset($_path["file"]))
 {
  if(strrpos($_SERVER["SCRIPT_NAME"], "/")!==false)
   $_path["file"]=substr($_SERVER["SCRIPT_NAME"], (strrpos($_SERVER["SCRIPT_NAME"], "/")+1));
  else
   $_path["file"]=$_SERVER["SCRIPT_NAME"];
 }

 //set HTML paths
 if(!isset($_path["HTML"]))
 {
  if(strrpos($_SERVER["SCRIPT_NAME"], "/")!==false)
   $_path["HTML"]["current"]=substr($_SERVER["SCRIPT_NAME"], 0, (strrpos($_SERVER["SCRIPT_NAME"], "/")+1));
  else
   $_path["HTML"]["current"]="/";

  if($l=substr_count($_path["root"], "../")) //remove directories up till root
  {
   $_path["HTML"]["root"]=explode("/", $_path["HTML"]["current"]);
   $_path["HTML"]["root"]=array_slice($_path["HTML"]["root"], 0, -($l+1));
   $_path["HTML"]["root"]=implode("/", $_path["HTML"]["root"])."/";
  }
  else
   $_path["HTML"]["root"]=$_path["HTML"]["current"];

  if(isset($_SERVER["REQUEST_URI"])) //not set when run from cli
   $_path["HTML"]["url"]=preg_replace("!\?.*$!", "", urldecode($_SERVER["REQUEST_URI"])); //remove arguments
  else
   $_path["HTML"]["url"]="";

  $relativePath=$_path["HTML"]["url"];

  if(strlen($_path["HTML"]["current"])>1) //get relative path
   $relativePath=preg_replace("!^".preg_quote($_path["HTML"]["current"], "!")."!", "", $relativePath, 1); //strip root path

  if($relativePath)
  {
   if(strlen($relativePath)==1&&$relativePath[0]=="/") // "/"
    $relativePath=""; //root
   else if($relativePath[0]=="/") //leading "/"
    $relativePath=preg_replace("!^/(.+/)[^/]*$!", "\\1", $relativePath); //remove leading "/" and script file
   else
    $relativePath=preg_replace("![^/]*$!", "\\1", $relativePath); //remove script file
  }

  $_path["HTML"]["relative"]=$relativePath;
  $_path["HTML"]["prefix"]=str_repeat("../", substr_count($relativePath, "/"));

  unset($l, $relativePath);
 }

 //set project paths
 if(isset($_session)&&$_session->get("project"))
 {
  if(!isset($_path["project"]["root"]))
   $_path["project"]["root"]=$_path["projects"].$_session->get("project")."/";
  if(!isset($_path["project"]["html"]))
   $_path["project"]["html"]=$_path["project"]["root"]."html/";
  if(!isset($_path["project"]["images"]))
   $_path["project"]["images"]=$_path["project"]["root"]."images/";
  if(!isset($_path["project"]["include"]))
   $_path["project"]["include"]=$_path["project"]["root"]."include/";
  if(!isset($_path["project"]["data"]))
   $_path["project"]["data"]=$_path["project"]["include"]."data/";
  if(!isset($_path["project"]["modules"]))
   $_path["project"]["modules"]=$_path["project"]["include"]."modules/";
  if(!isset($_path["project"]["plugins"]))
   $_path["project"]["plugins"]=$_path["project"]["include"]."plugins/";
  if(!isset($_path["project"]["script"]))
   $_path["project"]["script"]=$_path["project"]["root"]."script/";
  if(!isset($_path["project"]["style"]))
   $_path["project"]["style"]=$_path["project"]["root"]."style/";
  if(!isset($_path["project"]["download"]))
   $_path["project"]["download"]=$_path["project"]["root"]."download/";
  if(!isset($_path["project"]["templates"]))
   $_path["project"]["templates"]=$_path["project"]["root"]."templates/";
  if(!isset($_path["project"]["cache"]))
   $_path["project"]["cache"]=$_path["project"]["root"]."cache/";
 }

?>
