<?

 /*****************************************************************************
 * Filename: include/plugins/content/modules/pluginConfigs.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_content_pluginConfigs extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title="Content plugin configuration";
   $this->data->addField("title", "text", "all", "title", 0, 50, false, "Title");
   $this->data->addField("subtitle", "text", "all", false, 0, 255, false, "Subtitle");
   $this->data->addField("content", "html", "all", "wysiwyg", 0, 65535, false, "Content");

   $this->data->addField("wrappertag", "text", "all", "reload", 0, 10, "", "Wrapper tag");
   $this->data->listOptions("wrappertag", "", "div", "p", "ul");
   $this->data->addField("wrapperclass", "text", "all", false, 0, 25, "", "Wrapper tag class");

   $this->data->addField("titletag", "text", "all", "reload", 0, 10, "h1", "Title tag");
   $this->data->listOptions("titletag", "", "h1", "h2", "h3", "div", "p", "li");
   $this->data->addField("titleclass", "text", "all", false, 0, 25, "title", "Title tag class");

   $this->data->addField("subtitletag", "text", "all", "reload", 0, 10, "h2", "Subtitle tag");
   $this->data->listOptions("subtitletag", "", "h1", "h2", "h3", "div", "p", "li");
   $this->data->addField("subtitleclass", "text", "all", false, 0, 25, "subtitle", "Subtitle tag class");

   $this->data->addField("contenttag", "text", "all", "reload", 0, 10, "div", "Content tag");
   $this->data->listOptions("contenttag", "", "h1", "h2", "h3", "div", "p", "li");
   $this->data->addField("contentclass", "text", "all", false, 0, 25, "content", "Content tag class");

   $this->data->field["plugin"]["properties"]=preg_replace("/title/", "", $this->data->field["plugin"]["properties"]);

   $this->data->group("Content", "title", "subtitle", "content");
   $this->data->group("HTML Tags", "wrappertag", "titletag", "subtitletag", "contenttag", "wrapperclass", "titleclass", "subtitleclass", "contentclass");
  }

  function postInit(){return $this->customizeFields();}
  function copyPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}
  function movePostGet(){return $this->customizeFields();}
  function deletePostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   if($this->data->getValue("wrappertag"))
    $this->data->resetField("wrapperclass");
   else
    $this->data->field["wrapperclass"]["properties"].=";hidden";

   if($this->data->getValue("titletag"))
    $this->data->resetField("titleclass");
   else
    $this->data->field["titleclass"]["properties"].=";hidden";

   if($this->data->getValue("subtitletag"))
    $this->data->resetField("subtitleclass");
   else
    $this->data->field["subtitleclass"]["properties"].=";hidden";

   if($this->data->getValue("contenttag"))
    $this->data->resetField("contentclass");
   else
    $this->data->field["contentclass"]["properties"].=";hidden";

   return true;
  }

  function addPreSubmitErrorCheck(){return $this->contentCheck();}
  function copyPreSubmitErrorCheck(){return $this->contentCheck();}
  function editPreSubmitErrorCheck(){return $this->contentCheck();}

  function contentCheck()
  {
   if(
    !$this->data->getValue("title")&&
    !$this->data->getValue("subtitle")&&
    !trim($this->data->getValue("content"))
   )
   {
    if(
     !$this->data->getValue("wrappertag")&&
     !$this->data->getValue("titletag")&&
     !$this->data->getValue("subtitletag")&&
     !$this->data->getValue("contenttag")
    )
    {
     $this->data->e->add("No content or tags set, nothing will be outputted", "error");
     return false;
    }
    else
     $this->data->e->add("No content set, only tags will be outputted", "warning");
   }

   return true;
  }

 }
?>
