<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/cms.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."cms.php");

 class UT_CMS extends UT_Classes
 {
  function Constructor()
  {
   $object=new CMS();

   if(!is_object($object)||get_class($object)!="CMS")
   {
    $this->e->add("Constructor doesn't return a CMS object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   //config merge
   $object=new CMS(Array("showTitles" => false, "showFields" => false));

   if($object->config["showTitles"])
   {
    $this->e->add("CMS shouldn't show titles");
    return UT_FAILED;
   }

   if($object->config["showFields"])
   {
    $this->e->add("CMS shouldn't show fields");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Copy_Constructor()
  {
   $orig=new CMS();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("CMS object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->vars=Array("test");
   if($orig->vars==$copy->vars)
   {
    $this->e->add("CMS object copy also modified original \"vars\" variable", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("CMS object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   $copy->l->sets=Array("test");
   if($orig->l->sets==$copy->l->sets)
   {
    $this->e->add("CMS object copy also modified original \"Language\" object", "error");
    return UT_FAILED;
   }

   $orig->l->sets=Array("test");
   if($orig->l->sets!=$orig->e->l->sets)
   {
    $this->e->add("CMS object original didn't modify original \"Language\" object", "error");
    return UT_FAILED;
   }

   $copy->l->sets=Array("test2");
   if($copy->l->sets!=$copy->e->l->sets)
   {
    $this->e->add("CMS object copy didn't modify copy \"Language\" object", "error");
    return UT_FAILED;
   }

   //error
   $orig=new CMS();
   $orig->e->add("test 1");
   $orig->e->add("test 2");
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("CMS object copy doesn't match original", "error");
    return UT_FAILED;
   }

   //data / form
   $orig=new CMS();
   $orig->setDataForm(new Data(), new Form());
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("CMS object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->data->format=Array();
   if($orig->data->format!=$copy->data->format)
   {
    $this->e->add("CMS object copy didn't modified referenced \"Data\" variable", "error");
    return UT_FAILED;
   }

   $copy->form->form=-1;
   if($orig->form->form!=$copy->form->form)
   {
    $this->e->add("CMS object copy didn't modified referenced \"Form\" variable", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }

?>
