<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/language.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."language.php");

 class UT_Language extends UT_Classes
 {
  var $set="error";
  var $translations=Array(
       "Notes" => "Opmerkingen",
       "Warnings" => "Waarschuwingen",
       "Errors" => "Fouten",
       "Hacks" => "Hacks",
       "SQL" => "Database fouten",
       "System error" => "Systeem fouten",
       "Module error" => "Module fouten",
      );

  function Constructor()
  {
   global $_config;

   $object=new Language();

   if(!is_object($object)||get_class($object)!="Language")
   {
    $this->e->add("Constructor doesn't return a Language object", "error");
    return UT_FAILED;
   }

   if($object->original!="en")
   {
    $this->e->add("Constructor original language should be \"en\"", "error");
    return UT_FAILED;
   }

   if($object->language!=$_config->get("language"))
   {
    $this->e->add("Constructor language should be \"".$_config->get("language")."\"", "error");
    return UT_FAILED;
   }


   $object=new Language("nl", "en");

   if(!is_object($object)||get_class($object)!="Language")
   {
    $this->e->add("Constructor doesn't return a Language object", "error");
    return UT_FAILED;
   }

   if($object->original!="nl")
   {
    $this->e->add("Constructor original language should be \"nl\"", "error");
    return UT_FAILED;
   }

   if($object->language!="en")
   {
    $this->e->add("Constructor language should be \"en\"", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Clear()
  {
   return UT_SKIPPED;
  }


  function SetOriginal()
  {
   return UT_SKIPPED;
  }

  function SetLanguage()
  {
   return UT_SKIPPED;
  }

  function ShowErrors()
  {
   return UT_SKIPPED;
  }


  function GetFilename()
  {
   return UT_SKIPPED;
  }

  function Read()
  {
   return UT_SKIPPED;
  }

  function Updated()
  {
   return UT_SKIPPED;
  }

  function SetTranslation()
  {
   return UT_SKIPPED;
  }


  function Tnormal()
  {
   $l=new Language("en", "nl");

   if(!$l->read($this->set))
   {
    $this->e->add("Failed to read set: \"".$this->set."\"", "error");
    return UT_FAILED;
   }

   foreach($this->translations as $original => $translated)
   {
    if($l->t($original)!=$translated)
    {
     $this->e->add("Failed to translate: \"".$original."\" to \"".$translated."\"", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function Tlower()
  {
   $l=new Language("en", "nl");

   if(!$l->read($this->set))
   {
    $this->e->add("Failed to read set: \"".$this->set."\"", "error");
    return UT_FAILED;
   }

   foreach($this->translations as $original => $translated)
   {
    $original=strtolower($original);
    $translated=strtolower($translated);

    if($l->t($original)!=$translated)
    {
     $this->e->add("Failed to translate: \"".$original."\" to \"".$translated."\"", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function Tregexp()
  {
   return UT_SKIPPED;
  }


  function UTnormal()
  {
   $l=new Language("en", "nl");

   if(!$l->read($this->set))
   {
    $this->e->add("Failed to read set: \"".$this->set."\"", "error");
    return UT_FAILED;
   }

   foreach($this->translations as $original => $translated)
   {
    if($l->ut($translated)!=$original)
    {
     $this->e->add("Failed to untranslate: \"".$translated."\" to \"".$original."\"", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function UTlower()
  {
   $l=new Language("en", "nl");

   if(!$l->read($this->set))
   {
    $this->e->add("Failed to read set: \"".$this->set."\"", "error");
    return UT_FAILED;
   }

   foreach($this->translations as $original => $translated)
   {
    $original=strtolower($original);
    $translated=strtolower($translated);

    if($l->ut($translated)!=$original)
    {
     $this->e->add("Failed to untranslate: \"".$translated."\" to \"".$original."\"", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

 }

?>
