#!/bin/bash

 ##############################################################################
 # Filename: project/jas/images/icons/icon.sh
 #
 # This file is part of the JAS project.
 # Copyright 2003-2016 by Matthijs Schuurman
 #
 # The JAS project is free software under the terms of the
 # GNU Lesser General Public License version 3 or any later version.
 #
 # For information about the license please refer to:
 # LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 ##############################################################################


if [ ! $1 ]; then
 exit 1
elif [ ! $2 ]; then
 exit 2
fi

IN="$1"
OUT="$2"

WIDTH=128
HEIGHT=128

BRIGHTNESS=0
CONTRAST=0

if [ ! -f "$IN" ]; then 
 echo "File not found: $IN"
 exit 1
fi

convert "$IN" -filter box -resize ${WIDTH}x${HEIGHT} -colorspace Gray -brightness-contrast ${BRIGHTNESS}x${CONTRAST} "${OUT}_disabled.png"

convert "${OUT}_disabled.png" \( +clone +matte -fill '#1468A8' -colorize 100% \) -compose overlay -composite "${OUT}.png"
composite "${OUT}.png" "${OUT}_disabled.png" -compose atop "${OUT}.png"

convert "${OUT}_disabled.png" \( +clone +matte -fill '#EA0752' -colorize 100% \) -compose overlay -composite "${OUT}_link.png"
composite "${OUT}_link.png" "${OUT}_disabled.png" -compose atop "${OUT}_link.png"

convert "${OUT}_disabled.png" \( +clone +matte -fill '#0D4169' -colorize 100% \) -compose overlay -composite "${OUT}_dim.png"
composite "${OUT}_dim.png" "${OUT}_disabled.png" -compose atop "${OUT}_dim.png"
