<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/plugin.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");
 require_once($_path["include"]."history.php");
 require_once($_path["include"]."plugin.php");
 require_once($_path["include"]."jas.php");

 class Backend_Plugin extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);

   $this->plugin=false;
   $this->disabled=false;
  }

  function main($plugin=false)
  {
   global $_session;

   $_session->frontend();

   if($plugin)
   {
    if(!in_array($plugin, JAS::plugins()))
     $this->e->add("Plugin: \"".$plugin."\" not found", "error");
    else
    {
     $this->plugin=new Plugin($plugin);

     if(!$this->plugin->info())
      $this->e->add($this->plugin->e);

     if(!$this->plugin->classExists("backend"))
     {
      $this->e->add("Plugin: \"".$this->plugin->title."\" doesn't have a backend", "error");
      $_session->backend();
      return false;
     }

     if(!$this->plugin->isEnabled())
     {
      $this->e->add("Plugin: \"".$this->plugin->title."\" is disabled", "error");
      $this->disabled=true; //render enable link
      $_session->backend();
      return false;
     }

     if(!$this->backend->prettyurls) //vars
      foreach($this->backend->pageVars as $k => $page)
       $this->plugin->addVar("p[".$k."]", $page);

     $this->plugin->getClass("backend")->backend=&$this->backend; //hand backend to plugin

     if(!$this->plugin->call("backend", "main"))
      $this->plugin->failed=true; //don't render output
    }
   }

   $_session->backend();

   return true;
  }


  /*
   * Output
   */

  function output_default()
  {
   global $_session, $_config;

   $r="";
   $_session->frontend();

   if($this->plugin)
   {
    $this->backend->setTitle($this->icon("plugin_dim"),
     $this->link($this->plugin->l->t($this->plugin->title), Array("plugin/".$this->plugin->name."/")));

    if($this->disabled) //disabled
    {
     $this->menuItem("actions", $this->language->t("Enable"), $this->url("plugins/".$this->plugin->name."/", Array("enable" => 1)), $this->language->t("Enable ".$this->plugin->title." plugin"), "enable", Array((request("enable")!==NULL?"selected":false), (!$this->plugin->classExists("setup")||!$_config->userRoot()?"disabled":false)));

     $r.="<div class=\"twothird\">&nbsp;</div>\n";

     $r.="<div class=\"third\">\n";
     $r.="<h3>".$this->icon("execute_dim", "small")." ".$this->language->t("Actions")."</h3>\n";
     $r.=$this->menu("actions");
     $r.="</div>\n";
    }
    else
    {
     if(isset($this->plugin->failed)||($output=$this->plugin->call("backend", "output"))===false) //main/output failed
      $this->e->add($this->plugin->e); //show plugin errors
     else
      $r.=$output; //show output
    }
   }

   $_session->backend();

   return $r;
  }

 }
?>
