<?

 /*****************************************************************************
 * Filename: project/jas/include/modules/links.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["include"]."jas.php");
 require_once($_path["include"]."fs.php");

 class JAS_Module_links extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   $this->data->title="Link";

   $this->data->defaultFields();

   $this->data->addField("path", "text", "all", "title", 1, 255, false, "Path");
   $this->data->addField("title", "text", "all", "title", 1, 255, false, "Title");
   $this->data->addField("icon", "list", "all", "", 0, 25, false, "Icon");

   $this->data->addField("translate", "boolean", "all", "", false, false, true, "Translate title");
   $this->data->addField("rootonly", "boolean", "all", "", false, false, false, "Root only", "Only show for project root user");
   $this->data->addField("ordernr", "nr", "all", "order;hidden", false, false, 0, "Order number");

   $this->data->sortOrder("ordernr");
   $this->data->group("Options", "translate", "rootonly", "backendplugin", "ordernr");
  }

  function postInit(){return $this->customizeFields();}

  function customizeFields()
  {
   global $_path;

   //get backend links
   if($files=FS::filesS($_path["project"]["include"]."backend/", false, true))
   {
    sort($files);
    $plugins=JAS::plugins();
    $backend=Array("" => "");
    foreach($files as $file)
    {
     if($file=="base.php")
      continue;

     if(!preg_match("/^([a-z0-9]+)\.php$/i", $file, $m))
      continue;

     $backend[$m[1]."/"]=ucfirst($m[1]);

     if($file=="plugin.php")
      foreach($plugins as $plugin)
       $backend[$m[1]."/".$plugin."/"]="- ".ucfirst($plugin);
    }

    $this->data->listOptions("path", $backend);
   }

   //get icons
   if($files=FS::filesS($_path["project"]["images"]."icons/", false, true))
   {
    sort($files);
    $icons=Array("" => "");
    foreach($files as $file)
    {
     if(!preg_match("/^([a-z0-9]+)\.png$/i", $file, $m))
      continue;

//     $icons[$m[1]]="<img src=\"".$_path["HTML"]["prefix"].$_path["project"]["images"]."icons/".$file."\" class=\"icon small\"/> ".ucfirst($m[1]);
     $icons[$m[1]]=ucfirst($m[1]);
    }

    $this->data->listOptions("icon", $icons);
   }

   return true;
  }
 }
?>
